import socket
import pickle

from threading import *

_on_disconnection_funcs = []
_on_connection_funcs = []
_on_listening_funcs = []
_client_handler_func = None

def init(ip, port, client_arguments, recieve_size = 128, format = "utf-8"):
    global server, clients, connections, id, encoding_format, client_args, recv_size

    server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)

    encoding_format = format
    client_args = client_arguments
    recv_size = recieve_size

    try:
        server.bind((ip, port))

    except socket.error as e:
        print(str(e))
        quit()

    server.listen()

    clients = {}
    connections = 0
    id = 0

    for i in _on_listening_funcs:
        i()

    while True:
        connection, address = server.accept()

        new_thread = Thread(target = client_handler, args = (connection, address, id))
        new_thread.start()

        connections = connections + 1
        id = id + 1

def client_handler(connection, address, current_id):
    global server, clients, connections

    for i in _on_connection_funcs:
        i(address, current_id)

    clients[current_id] = client_args

    while True:
        try:
            data = connection.recv(recv_size)

            if not data:
                break

            data = data.decode(encoding_format)

            data = _client_handler_func(data, current_id, clients)
            data = pickle.dumps((data))

            connection.send(data)

        except Exception as e:
            print(e)
            break

    del clients[current_id]

    for i in _on_disconnection_funcs:
        i(address, current_id)

    connections = connections - 1 
    connection.close()

def handler(fn):
    global _client_handler_func

    _client_handler_func = fn

def on_connection(fn):
    global _on_connection_funcs

    _on_connection_funcs.append(fn)

def on_disconnection(fn):
    global _on_disconnection_funcs

    _on_disconnection_funcs.append(fn)

def on_listening(fn):
    global _on_listening_funcs

    _on_listening_funcs.append(fn)